program IO1213;

(***********************************
 * Programm zur Karte IO 1213 mit  *
 * 24 Eingngen und 24 Ausgngen   *
 ***********************************)

USES Crt;
TYPE    int_array = array [0..7] of integer;
CONST   adresse1 : integer = $100;
        adresse2 : integer = $104;
VAR     k,i,j,n  : integer;
        B        : integer;
        A        : int_array;

procedure Initialisieren;
begin
     Port[adresse1+3]:=$9B;
     Port[adresse2+3]:=$80;
end;

procedure Bildschirm;
begin
     gotoXY(5,2);write('>>>>>>> Testprogramm - 8255/1 = Einlesen ');
     write('- 8255/2 = Ausgeben <<<<<<<');
     gotoXY(15,23);write('>>>>>>>>>> Ende des Tests mit bel. Taste <<<<<<<<<<');
     for k:=1 to 3 do begin
         gotoXY(10,2+3*k);
         write('Port ',k);
     end;
end;

procedure Einlesen;
begin
     B:=1;
     for n:=1 to j do
         B:=2*B;
     Port[adresse2+i]:=B;
     delay(1);
     A[i]:=Port[adresse1+i];
end;

procedure Anzeigen;
var  K2   : integer;
     C,D  : integer;
begin
     delay(200);{Verzgerung, um Bildschirmausgabe verfolgen zu knnen}
     for k:=0 to 7 do begin
         K2:=1;
         for n:=1 to k do
             K2:=2*K2;
         C:=A[i] and K2;
         if C=0 then
            D:=0
         else
            D:=1;
         if D=0 then begin
            textattr:=black;
            Textbackground(7);
         end;
         gotoXY(30+4*k,5+3*i); write(' ',D,' ');
         textattr:=lightgray; Textbackground(7);
     end;
end;

BEGIN
     Initialisieren;
     Bildschirm;
     repeat
           for i:=0 to 2 do begin
               for j:=0 to 7 do begin
                   Einlesen;
                   Anzeigen;
               end;
           end;
     until keypressed;
END.